/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
import { SocksProxy } from 'socks';
import { Agent, AgentConnectOpts } from 'agent-base';
import * as net from 'net';
import * as tls from 'tls';
import * as http from 'http';
interface BaseSocksProxyAgentOptions {
    tls?: tls.ConnectionOptions | null;
}
interface SocksProxyAgentOptionsExtra {
    timeout?: number;
}
export interface SocksProxyAgentOptions extends BaseSocksProxyAgentOptions, Partial<Omit<SocksProxy, keyof BaseSocksProxyAgentOptions>> {
}
export declare class SocksProxyAgent extends Agent {
    static protocols: readonly ["socks", "socks4", "socks4a", "socks5", "socks5h"];
    private readonly shouldLookup;
    private readonly proxy;
    private readonly tlsConnectionOptions;
    timeout: number | null;
    constructor(uri: string | URL, opts?: SocksProxyAgentOptionsExtra);
    /**
     * Initiates a SOCKS connection to the specified SOCKS proxy server,
     * which in turn connects to the specified remote host and port.
     */
    connect(req: http.ClientRequest, opts: AgentConnectOpts): Promise<net.Socket>;
}
export {};
//# sourceMappingURL=index.d.ts.map